Index: kern/vfs_bio.c
===================================================================
RCS file: /cvs/src/sys/kern/vfs_bio.c,v
retrieving revision 1.18
diff -u -r1.18 vfs_bio.c
--- kern/vfs_bio.c	16 Feb 2004 19:37:48 -0000	1.18
+++ kern/vfs_bio.c	22 Feb 2004 07:16:41 -0000
@@ -351,7 +351,7 @@
 
 	TAILQ_INIT(&bswlist);
 	LIST_INIT(&invalhash);
-	lwkt_inittoken(&buftimetoken);
+	lwkt_token_init(&buftimetoken);
 
 	for (i = 0; i <= bufhashmask; i++)
 		LIST_INIT(&bufhashtbl[i]);
Index: kern/vfs_cache.c
===================================================================
RCS file: /cvs/src/sys/kern/vfs_cache.c,v
retrieving revision 1.12
diff -u -r1.12 vfs_cache.c
--- kern/vfs_cache.c	18 Oct 2003 05:53:57 -0000	1.12
+++ kern/vfs_cache.c	22 Feb 2004 06:09:02 -0000
@@ -792,17 +792,17 @@
 		VREF(vp);
 		error = 0;
 	} else if (flags & CNP_ISDOTDOT) {
-		VOP_UNLOCK(dvp, 0, td);
+		VOP_UNLOCK(dvp, NULL, 0, td);
 		cnp->cn_flags |= CNP_PDIRUNLOCK;
-		error = vget(vp, LK_EXCLUSIVE, td);
+		error = vget(vp, NULL, LK_EXCLUSIVE, td);
 		if (!error && lockparent && (flags & CNP_ISLASTCN)) {
-			if ((error = vn_lock(dvp, LK_EXCLUSIVE, td)) == 0)
+			if ((error = vn_lock(dvp, NULL, LK_EXCLUSIVE, td)) == 0)
 				cnp->cn_flags &= ~CNP_PDIRUNLOCK;
 		}
 	} else {
-		error = vget(vp, LK_EXCLUSIVE, td);
+		error = vget(vp, NULL, LK_EXCLUSIVE, td);
 		if (!lockparent || error || !(flags & CNP_ISLASTCN)) {
-			VOP_UNLOCK(dvp, 0, td);
+			VOP_UNLOCK(dvp, NULL, 0, td);
 			cnp->cn_flags |= CNP_PDIRUNLOCK;
 		}
 	}
@@ -815,12 +815,12 @@
 			return (0);
 		vput(vp);
 		if (lockparent && dvp != vp && (flags & CNP_ISLASTCN)) {
-			VOP_UNLOCK(dvp, 0, td);
+			VOP_UNLOCK(dvp, NULL, 0, td);
 			cnp->cn_flags |= CNP_PDIRUNLOCK;
 		}
 	}
 	if (cnp->cn_flags & CNP_PDIRUNLOCK) {
-		error = vn_lock(dvp, LK_EXCLUSIVE, td);
+		error = vn_lock(dvp, NULL, LK_EXCLUSIVE, td);
 		if (error)
 			return (error);
 		cnp->cn_flags &= ~CNP_PDIRUNLOCK;
Index: kern/vfs_conf.c
===================================================================
RCS file: /cvs/src/sys/kern/vfs_conf.c,v
retrieving revision 1.6
diff -u -r1.6 vfs_conf.c
--- kern/vfs_conf.c	7 Aug 2003 21:17:23 -0000	1.6
+++ kern/vfs_conf.c	22 Feb 2004 03:08:27 -0000
@@ -177,6 +177,7 @@
 	char		*vfsname, *path;
 	int		error;
 	char		patt[32];
+	lwkt_tokref	ilock;
 	int		s;
 
 	vfsname = NULL;
@@ -235,9 +236,9 @@
 	} else {
 
 		/* register with list of mounted filesystems */
-		lwkt_gettoken(&mountlist_token);
+		lwkt_gettoken(&ilock, &mountlist_token);
 		TAILQ_INSERT_HEAD(&mountlist, mp, mnt_list);
-		lwkt_reltoken(&mountlist_token);
+		lwkt_reltoken(&ilock);
 
 		/* sanity check system clock against root fs timestamp */
 		inittodr(mp->mnt_time);
Index: kern/vfs_default.c
===================================================================
RCS file: /cvs/src/sys/kern/vfs_default.c,v
retrieving revision 1.8
diff -u -r1.8 vfs_default.c
--- kern/vfs_default.c	26 Aug 2003 21:09:02 -0000	1.8
+++ kern/vfs_default.c	22 Feb 2004 07:17:03 -0000
@@ -241,6 +241,7 @@
 vop_stdlock(ap)
 	struct vop_lock_args /* {
 		struct vnode *a_vp;
+		lwkt_tokref_t a_vlock;
 		int a_flags;
 		struct proc *a_p;
 	} */ *ap;
@@ -249,14 +250,14 @@
 
 	if ((l = (struct lock *)ap->a_vp->v_data) == NULL) {
 		if (ap->a_flags & LK_INTERLOCK)
-			lwkt_reltoken(&ap->a_vp->v_interlock);
+			lwkt_reltoken(ap->a_vlock);
 		return 0;
 	}
 
 #ifndef	DEBUG_LOCKS
-	return (lockmgr(l, ap->a_flags, &ap->a_vp->v_interlock, ap->a_td));
+	return (lockmgr(l, ap->a_flags, ap->a_vlock, ap->a_td));
 #else
-	return (debuglockmgr(l, ap->a_flags, &ap->a_vp->v_interlock, ap->a_td,
+	return (debuglockmgr(l, ap->a_flags, ap->a_vlock, ap->a_td,
 	    "vop_stdlock", ap->a_vp->filename, ap->a_vp->line));
 #endif
 }
@@ -265,6 +266,7 @@
 vop_stdunlock(ap)
 	struct vop_unlock_args /* {
 		struct vnode *a_vp;
+		lwkt_tokref_t a_vlock;
 		int a_flags;
 		struct thread *a_td;
 	} */ *ap;
@@ -273,12 +275,11 @@
 
 	if ((l = (struct lock *)ap->a_vp->v_data) == NULL) {
 		if (ap->a_flags & LK_INTERLOCK)
-			lwkt_reltoken(&ap->a_vp->v_interlock);
+			lwkt_reltoken(ap->a_vlock);
 		return 0;
 	}
 
-	return (lockmgr(l, ap->a_flags | LK_RELEASE,
-		    &ap->a_vp->v_interlock, ap->a_td));
+	return (lockmgr(l, ap->a_flags | LK_RELEASE, ap->a_vlock, ap->a_td));
 }
 
 int
@@ -355,6 +356,7 @@
 vop_sharedlock(ap)
 	struct vop_lock_args /* {
 		struct vnode *a_vp;
+		lwkt_tokref_t a_vlock;
 		int a_flags;
 		struct proc *a_p;
 	} */ *ap;
@@ -379,7 +381,7 @@
 
 	if (l == NULL) {
 		if (ap->a_flags & LK_INTERLOCK)
-			lwkt_reltoken(&ap->a_vp->v_interlock);
+			lwkt_reltoken(ap->a_vlock);
 		return 0;
 	}
 	switch (flags & LK_TYPE_MASK) {
@@ -409,9 +411,9 @@
 	if (flags & LK_INTERLOCK)
 		vnflags |= LK_INTERLOCK;
 #ifndef	DEBUG_LOCKS
-	return (lockmgr(l, vnflags, &vp->v_interlock, ap->a_td));
+	return (lockmgr(l, vnflags, ap->a_vlock, ap->a_td));
 #else
-	return (debuglockmgr(l, vnflags, &vp->v_interlock, ap->a_td,
+	return (debuglockmgr(l, vnflags, ap->a_vlock, ap->a_td,
 	    "vop_sharedlock", vp->filename, vp->line));
 #endif
 }
@@ -426,6 +428,7 @@
 vop_nolock(ap)
 	struct vop_lock_args /* {
 		struct vnode *a_vp;
+		lwkt_tokref_t a_vlock;
 		int a_flags;
 		struct proc *a_p;
 	} */ *ap;
@@ -466,14 +469,14 @@
 	}
 	if (flags & LK_INTERLOCK)
 		vnflags |= LK_INTERLOCK;
-	return(lockmgr(vp->v_vnlock, vnflags, &vp->v_interlock, ap->a_p));
+	return(lockmgr(vp->v_vnlock, vnflags, ap->a_vlock, ap->a_p));
 #else /* for now */
 	/*
 	 * Since we are not using the lock manager, we must clear
 	 * the interlock here.
 	 */
 	if (ap->a_flags & LK_INTERLOCK)
-		lwkt_reltoken(&ap->a_vp->v_interlock);
+		lwkt_reltoken(ap->a_vlock);
 	return (0);
 #endif
 }
@@ -485,12 +488,13 @@
 vop_nounlock(ap)
 	struct vop_unlock_args /* {
 		struct vnode *a_vp;
+		lwkt_tokref_t a_vlock;
 		int a_flags;
 		struct proc *a_p;
 	} */ *ap;
 {
 	if (ap->a_flags & LK_INTERLOCK)
-		lwkt_reltoken(&ap->a_vp->v_interlock);
+		lwkt_reltoken(ap->a_vlock);
 	return (0);
 }
 
@@ -547,9 +551,9 @@
 		vp->v_usecount--;
 	} else {
 		if (object->flags & OBJ_DEAD) {
-			VOP_UNLOCK(vp, 0, td);
+			VOP_UNLOCK(vp, NULL, 0, td);
 			tsleep(object, 0, "vodead", 0);
-			vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+			vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 			goto retry;
 		}
 	}
Index: kern/vfs_lookup.c
===================================================================
RCS file: /cvs/src/sys/kern/vfs_lookup.c,v
retrieving revision 1.9
diff -u -r1.9 vfs_lookup.c
--- kern/vfs_lookup.c	9 Nov 2003 20:29:59 -0000	1.9
+++ kern/vfs_lookup.c	22 Feb 2004 06:04:47 -0000
@@ -182,7 +182,7 @@
 			return (0);
 		}
 		if ((cnp->cn_flags & CNP_LOCKPARENT) && ndp->ni_pathlen == 1)
-			VOP_UNLOCK(ndp->ni_dvp, 0, cnp->cn_td);
+			VOP_UNLOCK(ndp->ni_dvp, NULL, 0, cnp->cn_td);
 		if (ndp->ni_loopcnt++ >= MAXSYMLINKS) {
 			error = ELOOP;
 			break;
@@ -314,7 +314,7 @@
 	cnp->cn_flags &= ~CNP_ISSYMLINK;
 	dp = ndp->ni_startdir;
 	ndp->ni_startdir = NULLVP;
-	vn_lock(dp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(dp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 
 dirloop:
 	/*
@@ -394,7 +394,7 @@
 		}
 		ndp->ni_vp = dp;
 		if (!(cnp->cn_flags & (CNP_LOCKPARENT | CNP_LOCKLEAF)))
-			VOP_UNLOCK(dp, 0, cnp->cn_td);
+			VOP_UNLOCK(dp, NULL, 0, cnp->cn_td);
 		/* XXX This should probably move to the top of function. */
 		if (cnp->cn_flags & CNP_SAVESTART)
 			panic("lookup: CNP_SAVESTART");
@@ -434,7 +434,7 @@
 			dp = dp->v_mount->mnt_vnodecovered;
 			vput(tdp);
 			VREF(dp);
-			vn_lock(dp, LK_EXCLUSIVE | LK_RETRY, td);
+			vn_lock(dp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 		}
 	}
 
@@ -461,7 +461,7 @@
 			else
 				vput(tdp);
 			VREF(dp);
-			vn_lock(dp, LK_EXCLUSIVE | LK_RETRY, td);
+			vn_lock(dp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 			goto unionlookup;
 		}
 
@@ -516,9 +516,9 @@
 	 */
 	while (dp->v_type == VDIR && (mp = dp->v_mountedhere) &&
 	       (cnp->cn_flags & CNP_NOCROSSMOUNT) == 0) {
-		if (vfs_busy(mp, 0, 0, td))
+		if (vfs_busy(mp, 0, NULL, td))
 			continue;
-		VOP_UNLOCK(dp, 0, td);
+		VOP_UNLOCK(dp, NULL, 0, td);
 		error = VFS_ROOT(mp, &tdp);
 		vfs_unbusy(mp, td);
 		if (error) {
@@ -590,13 +590,13 @@
 		vrele(ndp->ni_dvp);
 
 	if ((cnp->cn_flags & CNP_LOCKLEAF) == 0)
-		VOP_UNLOCK(dp, 0, td);
+		VOP_UNLOCK(dp, NULL, 0, td);
 	return (0);
 
 bad2:
 	if ((cnp->cn_flags & (CNP_LOCKPARENT | CNP_PDIRUNLOCK)) == CNP_LOCKPARENT &&
 	    *ndp->ni_next == '\0')
-		VOP_UNLOCK(ndp->ni_dvp, 0, td);
+		VOP_UNLOCK(ndp->ni_dvp, NULL, 0, td);
 	vrele(ndp->ni_dvp);
 bad:
 	if (dpunlocked)
@@ -638,7 +638,7 @@
 	rdonly = cnp->cn_flags & CNP_RDONLY;
 	cnp->cn_flags &= ~CNP_ISSYMLINK;
 	dp = dvp;
-	vn_lock(dp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(dp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 
 /* dirloop: */
 	/*
@@ -672,7 +672,7 @@
 			goto bad;
 		}
 		if (!(cnp->cn_flags & CNP_LOCKLEAF))
-			VOP_UNLOCK(dp, 0, td);
+			VOP_UNLOCK(dp, NULL, 0, td);
 		*vpp = dp;
 		/* XXX This should probably move to the top of function. */
 		if (cnp->cn_flags & CNP_SAVESTART)
@@ -736,12 +736,12 @@
 		vfs_object_create(dp, cnp->cn_td);
 
 	if ((cnp->cn_flags & CNP_LOCKLEAF) == 0)
-		VOP_UNLOCK(dp, 0, td);
+		VOP_UNLOCK(dp, NULL, 0, td);
 	return (0);
 
 bad2:
 	if ((cnp->cn_flags & CNP_LOCKPARENT) && (cnp->cn_flags & CNP_ISLASTCN))
-		VOP_UNLOCK(dvp, 0, td);
+		VOP_UNLOCK(dvp, NULL, 0, td);
 	vrele(dvp);
 bad:
 	vput(dp);
